//
//  Controleur.m
//  Memoire
//
//  Created by Thomas Jannaud on 18/08/08.
//  Copyright 2008 Jannaud's Technical Company. All rights reserved.
//

#import "Controleur.h"
#import "Partie.h"
#import "MyView.h"
#import "Preference.h"

@implementation Controleur

-(void) awakeFromNib {
	[self show_record];
	is_showing_pref = NO;
	partie_en_cours = NO;
}

- (BOOL)windowShouldClose:(id)windo {
	is_showing_pref = NO;
	[bouton_start setEnabled:YES];
	return YES;
}

-(void) initialiser {
	[window init];
	[window dessine_fond];
	game = [[Partie alloc] init:window:self];
	[window setMaster:game];
	partie_en_cours = NO;
}

-(id) init {
	if (self = [super init])
		;
	
	return self;
}

-(IBAction)nouvellepartie:(id) sender {
	[bouton_start setHidden:YES];
	option = [Preference getGameType];
	[game start:option];
	partie_en_cours = YES;
	[MenuPrefs setEnabled:NO];
	[self info:@""];
}

-(IBAction)changeoption1:(id) sender {
	option = MortSubite;
	[Preference setGameType:option];
	[self show_record];
}

-(IBAction)changeoption2:(id) sender {
	option = DeuxViesEnTout;
	[Preference setGameType:option];
	[self show_record];
}

-(IBAction)changeoption3:(id) sender {
	option = DeuxViesParTour;
	[Preference setGameType:option];
	[self show_record];
}

-(IBAction)RAZRecords:(id) sender {
	NSAlert *alert = [[[NSAlert alloc] init] autorelease]; 
	[alert addButtonWithTitle:@"No"]; 
	[alert addButtonWithTitle:@"Yes"]; 
	[alert setMessageText:@"Voulez-vous vraiment supprimer les records établis ?"]; 
	[alert setInformativeText:@"Cette opération est irréversible."]; 
	[alert setAlertStyle:NSWarningAlertStyle];
	int a =	[alert runModal]; //:WindowPrefs modalDelegate:self didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:nil]; 
	if (a == 1001)
		[Preference resetRecords];
}

-(void) raz {
	[bouton_start setHidden:NO];
	//	[game release];
}

-(void) show_record {
	option = [Preference getGameType];
	NSNumber* r = [NSNumber numberWithInt:[Preference getRecord:option]];
	[LabelRecord setStringValue:[@"Record : " stringByAppendingString:[r stringValue]]];
}

-(void) info:(NSString*) message {
	[LabelInfo setStringValue:message];
}

-(void) end_game {
	partie_en_cours = NO;
	[MenuPrefs setEnabled:YES];
}

-(IBAction)ShowPrefs:(id) sender {
	if (partie_en_cours)
		return;
	
	is_showing_pref = YES;
	[bouton_start setEnabled:NO];
	[WindowPrefs makeKeyAndOrderFront:self];
	option = [Preference getGameType];
	[option1 setState:0];
	[option2 setState:0];
	[option3 setState:0];
	
	if (option == MortSubite)
		[option1 setState:1];
	else if (option == DeuxViesEnTout)
		[option2 setState:1];
	else
		[option3 setState:1];
}

+(void) initialize {
	[Preference initPref];
}

@end
