//
//  Created by Thomas Jannaud on 19/08/08.
//  Copyright 2008 Jannaud's Technical Company. All rights reserved.
//

#import "MyView.h"
#include <OpenGL/gl.h>
#import "Partie.h"
#import "animation.h"

@implementation MyView

-(void) dessine_carre:(float) x:(float) y:(float) widt:(float) heigh {
	glBegin(GL_POLYGON);
	{
		glVertex2f( x, y); // haut à gauche
		glVertex2f( x +  widt, y); // haut à droite
		glVertex2f( x + widt, y - heigh); // bas à droite
		glVertex2f( x, y - heigh); // bas à gauche
	}
	glEnd();
}

-(void) dessine_carre:(int) n:(NSColor*) couleur {
	CGFloat r = [couleur redComponent], g = [couleur greenComponent], bb = [couleur blueComponent];
	glColor3f(r, g, bb);
	[self dessine_carre:-0.90 + .95 * (n % 2) :0.90 - .95 * (n / 2) :0.85 :0.85];
}

-(void) dessine_fond {
	for(int i = 0; i < 4; i++)
		[self dessine_carre:i:couleurs[i]];
}

-(float) f:(float) x: (float) l {
	if (x < .98) {
		float y = 4. * (.5 - l) * (.5 - l);
		return y * x + 1.0 * (1 - y);
	}
	else
		return x * (.3 + l) / 1.3;
}

-(void) animation_step:(int) etape {
	NSRect t;
	[self drawRect:t];
}

-(void) animation_fin {
	isAnimating = NO;
	[toto release];
	NSRect t;
	[self drawRect:t];
}


// animation du carré n
-(void) animer:(int) n {
	if (isAnimating)
		[toto die];
	isAnimating = YES;
	in_motion = n;
	toto = [[animation alloc] init:10 :0.06 :YES :YES :self :@selector(animation_step:) :@selector(animation_fin)];
	[toto lancer];
}

-(void) setMaster:(Partie*) parti {
	master = parti;
}

-(MyView*) init {
	/*		for(int i = 0; i < 4; i++)
	 couleurs[i] = [[NSColor colorWithCalibratedHue: ((5*i+1)*0.04) saturation: 1 brightness: 0.9 alpha: 1] retain];*/
	couleurs[0] = [NSColor blueColor];
	couleurs[1] = [NSColor redColor];
	couleurs[2] = [NSColor greenColor];
	couleurs[3] = [NSColor yellowColor];
	
	isAnimating = NO;
	
	return self;
}

-(void) drawRect: (NSRect) bounds {
	glClearColor(0, 0, 0, 0);
	glClear(GL_COLOR_BUFFER_BIT);
	[self dessine_fond];
	
	if (isAnimating) {
		int n = in_motion;
		CGFloat h = [couleurs[n] hueComponent], s = [couleurs[n] saturationComponent], b = [couleurs[n] brightnessComponent], e = toto.step / 9.0;
		NSColor*	unecouleur = [NSColor colorWithCalibratedHue: [self f: h: e] saturation: s brightness: b alpha: 1];		
		[self dessine_carre:in_motion:unecouleur];
	}
	glFlush();	
}

CGFloat f_graph(CGFloat x,CGFloat total) {
	return (1.0+x)/2.0 * total;
}

-(void)mouseUp:(NSEvent *)theEvent {
	NSPoint eventLocation = [theEvent locationInWindow];
	CGFloat x = eventLocation.x - [self frame].origin.x;
	CGFloat y = eventLocation.y - [self frame].origin.y;
	CGFloat larg = [self bounds].size.width;
	CGFloat haut = [self bounds].size.height;
	
	for(int i = 0; i < 4; i++)
		if (x > f_graph(-0.90 + .95 * (i % 2), larg) && x < f_graph(-0.05 + .95 * (i % 2), larg) && y < f_graph(0.95 - .95 * (i / 2), haut) && y > f_graph(0.05 - .95 * (i / 2), haut)) {
			if ([master recoitclic:i])
				[self animer:i];
		}
}

- (BOOL)isFlipped {
	return YES;
}


@end